import javax.swing.*;
import org.jfree.chart.*;
import org.jfree.chart.plot.*;
import org.jfree.data.xy.*;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;

/**
 *      
 * . .   ,  < > -1969
 *     JFreeChart http://www.jfree.org/jfreechart/ v1.0.11
 */
public class DiskHardPlasticDeformation implements ActionListener {

    double Xo, Yo, Zo, Xmax;
    double nu, E, m, c;
    double k=1;
    double xmin;
    double xmax;
    double ymin;
    double ymax;
    double h_gr=0.0001;

    ChartPanel chartPanel = null;
    JScrollPane scrollPane = new JScrollPane();
    JFrame frame1 = new JFrame("  ,  ");

    //  
    JTextField tf_nu = new JTextField("0.3");
    JTextField tf_E = new JTextField("2E6");
    JTextField tf_m = new JTextField("2.75");
    JTextField tf_c = new JTextField("2E3");
    JTextField tf_h = new JTextField("0.0001");


    JTextField tf_xmin = new JTextField("0.0001");  //   -  u  w - 
    JTextField tf_xmax = new JTextField("1");
    JTextField tf_ymin = new JTextField("0");
    JTextField tf_ymax = new JTextField("1.5");
    JLabel l_xmin = new JLabel("XMin:");
    JLabel l_xmax = new JLabel("XMax:");
    JLabel l_ymin = new JLabel("YMin:");
    JLabel l_ymax = new JLabel("YMax:");


    JCheckBox jcbElastic = new JCheckBox(" ");
    JCheckBox jcbElasticPlastic1Zone = new JCheckBox("- ");
    JCheckBox jcbElasticPlastic1ZoneStrength = new JCheckBox("-  ");

    public DiskHardPlasticDeformation() {
        buildFrame();
        buildGraph();
    }

    /**
     *  
     * @param args
     */
    public static void main(String[] args) {
        DiskHardPlasticDeformation rk = new DiskHardPlasticDeformation();

    }

    /**
     *   Omega, U    
     * @param series1
     * @param series2
     */

    public void calcRungeKuttOmegaU(XYSeries series1, XYSeries series2) {
        int k = 2;
        double Y1, Z1;
        double k1, k2, k4, k3, h;
        double q1, q2, q4, q3;
        /*
        * 
        */
        Xo = 0.0001;//start
        Yo = 0.00000005;
        Zo = 2 * 0.0001;
        Xmax = 1.68;

        double printX = Xo;
        double printStep = 0.01;

        h = h_gr; //  

        System.out.println("\tr\t\tw\t\tu");

        for (; Xo < Xmax; Xo += h) {

            k1 = h * f(Xo, Yo, Zo);
            q1 = h * g(Xo, Yo, Zo);

            k2 = h * f(Xo + h / 2.0, Yo + k1 / 2.0, Zo + q1 / 2.0);
            q2 = h * g(Xo + h / 2.0, Yo + k1 / 2.0, Zo + q1 / 2.0);

            k3 = h * f(Xo + h / 2.0, Yo + k2 / 2.0, Zo + q2 / 2.0);
            q3 = h * g(Xo + h / 2.0, Yo + k2 / 2.0, Zo + q2 / 2.0);

            k4 = h * f(Xo + h, Yo + k3, Zo + q3);
            q4 = h * g(Xo + h, Yo + k3, Zo + q3);

            Y1 = Yo + (1 / 6.0) * (k1 + 2.0 * k2 + 2.0 * k3 + k4);
            Z1 = Zo + (1 / 6.0) * (q1 + 2.0 * q2 + 2.0 * q3 + q4);

            // if (Xo<=printX && Xo+h>printX)
            //{
            System.out.println("\t" + r(Xo + h, k) + "\t\t" + r(Y1, k) + "\t\t" + r(Z1, k));
            series1.add(Xo, Y1);
            series2.add(Xo, Z1);
            printX += printStep;
            //}
            Yo = Y1;
            Zo = Z1;
        }

    }


    public double getF1(double x, double y) {
        return Math.sin(x);
    }


    /**
     * ,   f1  f2 -   
     * @param x
     * @param y
     * @param z
     * @return
     */
        public static double f(double x, double y, double z) {
        return ((x * x - Math.sin(y)) / (x * Math.sin(y + Math.PI / 6)));
    }

    public static double g(double x, double y, double z) {
        return (-z * Math.sin(y - Math.PI / 6) / (x * Math.sin(y + Math.PI / 6)));
    }

    /**
     *       SigmaR(R)
     * @param series1
     */
    public void calcRungeKuttPlastic(XYSeries series1) {
        int k = 2;
        double Y1, Z1;
        double k1, k2, k4, k3, h;

        Xo = 0.001;
        //Yo = 0.5 * Xo * Xo; //-?
        Zo = 1;
        Xmax = Double.parseDouble(tf_xmax.getText());

        double printX = Xo;
        double printStep = 0.01;

        h = h_gr; //  

//                System.out.println("\tX\t\tY\t\tZ");
        System.out.println("\tr\t\t\t\tSigmaR - 1");

        for (; Xo <= Xmax; Xo += h) {

            k1 = h * getFRKPlastic(Xo, Zo);

            k2 = h * getFRKPlastic(Xo + h / 2.0, Zo + 0.5 * k1);

            k3 = h * getFRKPlastic(Xo + h / 2.0, Zo + 0.5 * k2);

            k4 = h * getFRKPlastic(Xo + h, Zo + k3);

            Z1 = Zo + (1 / 6.0) * (k1 + 2.0 * k2 + 2.0 * k3 + k4);

            series1.add(Xo, Z1);
            printX += printStep;

            Zo = Z1;
        }

    }

     public void calcSRSTElastic(XYSeries seriesSR, XYSeries seriesST) {

        Xo = 0.001;
        Zo = 1;

        double r;
        double h = h_gr; //  
        double m=8/(3+nu);

        for (r=xmin; r <= xmax+h; r += h) {
            seriesSR.add(r, (3+nu)/8*m-(3+nu)/8*m*r*r);
            seriesST.add(r, (3+nu)/8*m-(1+3*nu)/8*m*r*r);
        }
    }

    public void calcSRSTElasticPlastic1Zone(XYSeries seriesSR, XYSeries seriesST) {

       Xo = 0.001;
       Zo = 1;

       double r;
       double r1=Math.sqrt(1-Math.sqrt((8-2*m)/(1+nu)/m));
       double h = h_gr; //  

       double B = 1-(3+nu)/8*m+(1+nu)/4*m*r1*r1;
       double A = B+(3+nu)/8*m;
       double mu = (1+3*nu)/(3+nu);

       for (r=xmin; r <= xmax+h; r += h) {

           if (r<r1)
           {
               seriesSR.add(r, k-0.25*m*r*r);
               seriesST.add(r, k+0.25*m*r*r);
           }
           else
           {
               seriesSR.add(r, B*(1-1/r/r)+((3+nu)/8)*m*(1-r*r));
               seriesST.add(r, B*(1+1/r/r)+((3+nu)/8)*m*(1-mu*r*r));
           }
       }
   }


   public void calcSRSTElasticPlastic1ZoneStrengthing(XYSeries seriesSR, XYSeries seriesST) {

       Xo = 0.001;
       Zo = 1;

       double r;
       double r1=Math.sqrt(1-Math.sqrt((8-2*m)/(1+nu)/m));
       double h = h_gr; //  

       double mu = (1+3*nu)/(3+nu);
       double rs1;
       double m_rasch_old=0;
       double rsUS=-1;

       for (rs1=0;rs1<=1;rs1+=h/2)
       {
            double m_rasch = (8*k)/(2* (E+3*c-3*c*nu)/(E+6*c)*rs1*rs1*rs1*rs1 - (1-nu)*rs1*rs1*rs1*rs1 -2*(1+nu)*rs1*rs1 + (3+nu) );

            if (rs1>0 && ((m_rasch>=m) && (m_rasch_old<=m) || (m_rasch<=m) && (m_rasch_old>=m)))
            {
                rsUS = rs1;
                break;
            }
            m_rasch_old = m_rasch;
       }

       double C1 = k+1.5*c*(1+nu)*m*rsUS*rsUS/(E+6*c);
       double B = k- (3+nu)*m/8+(1+nu)*m*rsUS*rsUS/4;

       for (r=xmin; r <= xmax+h; r += h) {

           if (r<rsUS)
           {
               seriesSR.add(r, C1 - (E+9*c+3*c*nu)*m*r*r/(4*(E+6*c)));
               seriesST.add(r, C1 + (E-3*c-9*c*nu)*m*r*r/(4*(E+6*c)));
           }
           else
           {
               seriesSR.add(r, B*(1-1/(r*r))+(3+nu)*m*(1-r*r)/8);
               seriesST.add(r, B*(1+1/(r*r))+(3+nu)*m*(1-mu*r*r)/8);
           }
       }
   }

    /**
     *     dSigmaR/dr
     * @param r
     * @param sigmar
     * @return
     */
    public double getFRKPlastic(double r, double sigmar) {
        double k = 1;
        double ro = 6.6;
        double omega = 1;
        double res = (Math.sqrt(4 - 3 * sigmar * sigmar) - sigmar) / (2.0 * r) - ro * omega * omega * r / (2.0 * k);
        return res;
    }


    /**
     *   
     */
    public static double r(double value, int k) {
        return (double) Math.round((Math.pow(10, k) * value)) / Math.pow(10, k);
    }

    /**
     *  
     */
    public void buildGraph() {

        readParams();
        //calcRungeKuttOmegaU(seriesOmega, seriesU);

        XYSeries seriesSigmaRKPlastic = new XYSeries("SigmaRKPlastic(r)");
        calcRungeKuttPlastic(seriesSigmaRKPlastic);

        XYSeriesCollection xyDataset = new XYSeriesCollection();

        int iSeriesCount = 0;
        final XYLineAndShapeRenderer renderer = new XYLineAndShapeRenderer(true, false);
        renderer.setSeriesShape(0,null);

        if (jcbElastic.isSelected())
        {
            XYSeries seriesSRElastic = new XYSeries("SigmaR (r)");
            XYSeries seriesSTElastic = new XYSeries("SigmaTheta (r)");
            calcSRSTElastic(seriesSRElastic, seriesSTElastic);
            xyDataset.addSeries(seriesSRElastic);
            xyDataset.addSeries(seriesSTElastic);

            renderer.setSeriesPaint(iSeriesCount++,new Color(0,0,255));
            renderer.setSeriesPaint(iSeriesCount++,new Color(0,0,180));
        }

        if (jcbElasticPlastic1Zone.isSelected())
        {
            XYSeries seriesSRElastic = new XYSeries("SigmaR (r)");
            XYSeries seriesSTElastic = new XYSeries("SigmaTheta (r)");
            calcSRSTElasticPlastic1Zone(seriesSRElastic, seriesSTElastic);
            xyDataset.addSeries(seriesSRElastic);
            xyDataset.addSeries(seriesSTElastic);   

            renderer.setSeriesPaint(iSeriesCount++,new Color(0,255,0));
            renderer.setSeriesPaint(iSeriesCount++,new Color(0,180,0));
        }

        if (jcbElasticPlastic1ZoneStrength.isSelected())
        {
            XYSeries seriesSRElastic = new XYSeries("SigmaR (r)");
            XYSeries seriesSTElastic = new XYSeries("SigmaTheta (r)");
            calcSRSTElasticPlastic1ZoneStrengthing(seriesSRElastic, seriesSTElastic);
            xyDataset.addSeries(seriesSRElastic);
            xyDataset.addSeries(seriesSTElastic);

            renderer.setSeriesPaint(iSeriesCount++,new Color(255,0,0));
            renderer.setSeriesPaint(iSeriesCount++,new Color(180,0,0));
        }


        JFreeChart chart = ChartFactory.createXYLineChart(" ", "", "", xyDataset, PlotOrientation.VERTICAL, true, true, false);
        XYPlot plot = (XYPlot) chart.getPlot();


        plot.setRenderer(renderer);

        if (chartPanel == null)
            chartPanel = new ChartPanel(chart);
        else
            chartPanel.setChart(chart);

        plot.getDomainAxis().setLowerBound(xmin);
        plot.getDomainAxis().setUpperBound(xmax);
        plot.getRangeAxis().setLowerBound(ymin);
        plot.getRangeAxis().setUpperBound(ymax);

        frame1.repaint();


    }

    public void readParams()
    {
        try {
              xmin = Double.parseDouble(tf_xmin.getText());
          } catch (Exception e) {
          }
          ;

          try {
              xmax = Double.parseDouble(tf_xmax.getText());
          } catch (Exception e) {
          }
          ;

          try {
              ymin = Double.parseDouble(tf_ymin.getText());
          } catch (Exception e) {
          }
          ;

          try {
              ymax = Double.parseDouble(tf_ymax.getText());
          } catch (Exception e) {
          }
          ;


          try {
              nu = Double.parseDouble(tf_nu.getText());
          } catch (Exception e) {
          }

          try {
              E = Double.parseDouble(tf_E.getText());
          } catch (Exception e) {
          }
        try {
            m = Double.parseDouble(tf_m.getText());
        } catch (Exception e) {
        }

        try {
            c = Double.parseDouble(tf_c.getText());
        } catch (Exception e) {
        }
      try {
          h_gr = Double.parseDouble(tf_h.getText());
      } catch (Exception e) {
      }


    }

    /**
     *    
     */
    public void buildFrame() {
        frame1.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);

        GridBagLayout lay = new GridBagLayout();
        frame1.setLayout(lay);

        GridBagConstraints c = new GridBagConstraints();
        c.insets = new Insets(5, 5, 5, 5);
        c.anchor = GridBagConstraints.WEST;


        c.gridx = 0;
        c.gridy = 1;
        c.weightx = 0.0;
        c.gridwidth = 2;
        frame1.add(new JLabel(" "), c);

        c.gridy = 2;
        c.gridwidth = 2;
        frame1.add(jcbElastic, c);
        jcbElastic.addActionListener(this);

        c.gridy = 3;
        c.gridwidth = 2;
        frame1.add(jcbElasticPlastic1Zone, c);
        jcbElasticPlastic1Zone.addActionListener(this);


        c.gridy = 4;
        c.gridwidth = 2;
        frame1.add(jcbElasticPlastic1ZoneStrength, c);
        jcbElasticPlastic1ZoneStrength.addActionListener(this);

        c.gridx = 0;
        c.gridy = 50;
        c.weightx = 0.0;
        c.gridwidth = 1;
        frame1.add(new JLabel("Nu(- ):"), c);
        c.gridx = 1;
        c.weightx = 1.0;
        tf_nu.setPreferredSize(new Dimension(100,20));
        frame1.add(tf_nu, c);

        c.gridx = 0;
        c.gridy = 51;
        c.weightx = 0.0;
        c.gridwidth = 1;
        frame1.add(new JLabel("E ( ):"), c);
        c.gridx = 1;
        c.weightx = 1.0;
        tf_E.setPreferredSize(new Dimension(100,20));
        frame1.add(tf_E, c);

        c.gridx = 0;
        c.gridy = 52;
        c.weightx = 0.0;
        c.gridwidth = 1;
        frame1.add(new JLabel("m (  ):"), c);
        c.gridx = 1;
        c.weightx = 1.0;
        tf_m.setPreferredSize(new Dimension(100,20));
        frame1.add(tf_m, c);

        c.gridx = 0;
        c.gridy = 53;
        c.weightx = 0.0;
        c.gridwidth = 1;
        frame1.add(new JLabel("c (- ):"), c);
        c.gridx = 1;
        c.weightx = 1.0;
        tf_c.setPreferredSize(new Dimension(100,20));
        frame1.add(tf_c, c);

        c.gridx = 0;
        c.gridy = 54;
        c.weightx = 0.0;
        c.gridwidth = 1;
        frame1.add(new JLabel("h (  ):"), c);
        c.gridx = 1;
        c.weightx = 1.0;
        tf_h.setPreferredSize(new Dimension(100,20));
        frame1.add(tf_h, c);

        c.gridx = 0;
        c.gridy = 100;
        c.gridwidth = 2;
        JButton b = new JButton("");
        b.addActionListener(this);
        frame1.add(b, c);

        c.gridx = 2;
        c.gridy = 100;
        c.gridwidth = 1;
        frame1.add(l_xmin, c);

        c.gridx = 3;
        c.weightx = 1.0;

        tf_xmin.setMinimumSize(new Dimension(80, 30));
        tf_xmin.setPreferredSize(new Dimension(80, 30));
        frame1.add(tf_xmin, c);

        c.gridx = 4;
        frame1.add(l_xmax, c);
        c.gridx = 5;
        tf_xmax.setMinimumSize(new Dimension(80, 30));
        tf_xmax.setPreferredSize(new Dimension(80, 30));
        frame1.add(tf_xmax, c);

        c.gridx = 6;
        frame1.add(l_ymin, c);

        c.gridx = 7;
        tf_ymin.setMinimumSize(new Dimension(80, 30));
        tf_ymin.setPreferredSize(new Dimension(80, 30));
        frame1.add(tf_ymin, c);

        c.gridx = 8;
        frame1.add(l_ymax, c);

        c.gridx = 9;
        tf_ymax.setMinimumSize(new Dimension(80, 30));
        tf_ymax.setPreferredSize(new Dimension(80, 30));
        frame1.add(tf_ymax, c);

        JFreeChart chart = ChartFactory.createXYLineChart(" ", "r", "w(ro)", null, PlotOrientation.VERTICAL, true, true, false);

        if (chartPanel == null)
            chartPanel = new ChartPanel(chart);
        scrollPane = new JScrollPane(chartPanel);

        c.gridx = 2;
        c.gridy = 0;
        c.weightx = 1.0;
        c.weighty = 1.0;
        c.gridheight = 99;
        c.gridwidth = 99;
        c.fill = java.awt.GridBagConstraints.BOTH;
        frame1.add(scrollPane, c);


        frame1.setSize(1280, 750);
        frame1.setVisible(true);
    }

    /**
     *  
     * @param e
     */
    public void actionPerformed(ActionEvent e) {
        buildGraph();
    }
}